--[[            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE*
                         Version 2, December 2004

        TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION:

        0. You just DO WHAT THE FUCK YOU WANT TO.

    ========================================================================    
      *look up the full license text by yourself, it only takes 10 seconds
    ========================================================================
	
    Common Organization of Controls Kit, version 1.3
    Copyright © 2013 Raidho36, the Pink Square Huge Jerk
	
	wiki page: http://www.love2d.org/wiki/Common_Organization_of_Controls_Kit
	project page: http://raidho36.net/stuff/cock
	
	REMARKS:
		* the code is bulky, but it's really fast; you can only have it any faster by discarding features
		* this library assumes you provide valid data, it won't handle programmers' errors, and foul code will most likely bluescreen with random error message
		* this code only nil-ing values to actually delete them, to unset them, it uses zeroes or falses
		* as of 0.8.0 which uses SDL1.2, under Windows XBox360 controller is not fully functional: both triggers are mapped to the same axis
		* delta modes yield delta value instead of absolute value; cutoff mode cuts off negative values
		* whole axis mode converts whole axis range -1..1 to 0..1, only works with joystick axis for obvious reasons; whole axis mode and deadzones ain't good friends
		* this library uses lookup table to resolve remapped/remodded joystick hats, I think it's way more effecient that way
		* text generating functions are kinda expensive and produce garbage, so lookup tables go out of bounds by having some of the computed values hard-coded in
		* callbacks are causing events flood pretty bad, so they're all disabled by default
		* some functions don't support colon notation, or have different sets of arguments, see the comments
		* many functions have down the letter identical snippets, these aren't chinese-style copypasted code, these are inlined functions (small functions needs to be inlined due to call overhead and Lua can't do it on it's own)
		* dummy joysticks only serve to be a placeholder to avoid functionality break on minor failures, but aren't actually handled
		
	TODO (sorted by priority):
		* make demos
		* proper XBox360 controller support (somewhat works for windows, doesn't work for other OSes)
		* love callback-based partial update (since 0.9.0)
		* add :load :save
		* create a "verbose" version
		* add broad feature axis amplifiers
		
	CHANGELOG:
		1.4:
			fixed:
			* problem with :update function and non-matching joystick hats
			* fixed malfunctioning .previous.* table
			added:
			* :serialize function to dump library data
			changed:
			* internal structure of the object, better update loop (still bulk as fuck)
			* shifted .etc.* subfields to object root
			* inverse and delta are now defaulted to long names (short names are left for compatibility)
			* renamed XBox360 default layout keys
			* :update no longer handles joystick hats (moved to .updateAll)
			* joystick objects moved to library root from object root; all joystick functons no longer support colon notaion
			* :reloadJoysticks will attempt to pick up all joysticks regardless of possible problems with bindings
			
		1.3:
			fixed:
			* code refactoring; improved consistency
			* fixed broken event handler locks
			* generating random IDs now work properly
			* fixed issue with spacebar key and :explodeCapturedData/:bind ( unexplodedData ) functions
			* fixed all :*Joystick* functions.
			* :addJoystick will now create a dummy joystick if it's impossible to actually create the joystick
			added:
			* .defaultOption and defaultConfig fields
			* :convertJoystickHat, :convertJoystickHatMode, :convertKey
			* :find returns control object with given ID
			* :updateAll updates all registered objects
			* :addJoystick and :removeJoystick (handled automatically)
			* .controlcaptured, .controlpeaked, .controlzeroed, .controlpressed, .controlreleased, .controlchanged callbacks
			* :setCallbacks for enabling/disabling above callbacks
			* :getCapture function
			* addded 4-way diagonal hat mode (4-way input, diagonal input generates both conjuncted directions input)
			chagned:
			* control objects now have unique identifiers
			* control binds data will no longer accept one-default arranged data
			* event callbacks are now supplied with ID of the sender object
			* all joystick-related functions now have "device id" field which specifies the joystick used in terms of control object
			* :setDefaultXBox360 now accepts device ID to use
			* :capturedDataExplode renamed to :explodeCapturedData (lol)
			* :getConverted* renamed to :convert*
			* conversion functions now have argument "literal" to force either literal or numerical output
			* :getBinded and pals are now return raw unconverted data
			* :setCapture function will now by default invoke the callback
			* renamed joystick hat modes
			* lookup tables will now grow further to avoid extra garbage/increase function performance
			* :setDefaultXBox360 now returns joystick ID (could change)
			removed:
			* :setControlMode and pals
			* :setDefaultXBox360 for Linux and OS X
			
		1.2:
			fixed:
			* a bunch of potential pitfalls
			* joystick axes and hats are now correctly captured
			added:
			* multiple binds per action via "options" tables
			* :setJoystickDeadzone and getJoystickDeadzone gets and sets joystick deadzone per axis
			* :getJoysticksList returns list of all found joysticks names and numbers
			* :remapJoystickHat maps four joystick buttons to act like joystick hat
			* :bind directly binds mappings
			* :getBinded returns list of binds for map
			* :getEmptyOption returns next (in arbitrary order) unused option for map
			* :getControlModesList returns list of all control modess
			* :getConvertedDevice, :getConvertedAxis, :getConvertedInverse, :getConvertedDelta
			* cutoff delta modes and inversion modes (only pass positive/negative part)
			* :setDefaultXBox360 function (currently used XBox360 controller API in Windows version sucks pretty hard)
			* :capturedDataExplode helper function (can't pass table to LÖVE's events)
			changed:
			* :setCapture now accepts "callback" argument to be used instead of instant automatical binding
			* :grab now would either call callback function or instantly bind captured input
			* :unset renamed to :unbind
			* controls data table for assignment now have different format
			* :getJoystickHatMode and :getControlMode now only return literal value
			* joystick axis delta mode no longer requires stick to be on the corresponding side either (that was silly, too)
			* added two-way delta modes
			* added no-cutoff for negative values for inversion
			removed:
			* :getDeviceName (replaced with :getBinded)

		1.1: 
			fixed:
			* capturing an input now sets both .previous and .current tables to captured input value
			* mouse axis delta mode no longer requires mouse pointer to be on the corresponding side of the offset (that was silly)
			added:
			* :getDeviceName function returns literal name of a device assiged to specified map
			changed:
			* :reloadJoystick now returns true on success
		
		1.0: 
			* first release version
--]]

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                               SYSTEM                                  ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
local cock = { ["_capture"] = { ["object"] = false, ["map"] = false, ["option"] = false, ["mouse"] = false, ["eventlock"] = false, ["updatelock"] = false, ["callback"] = false }, ["_objects"] = { }, ["joysticks"] = { } }

love.handlers.controlcaptured = function ( id, longarg ) if cock.controlcaptured then return cock.controlcaptured ( id, longarg ) else return cock.bind ( cock.find ( id ), longarg ) end end 
love.handlers.controlpressed = function ( id, k, v ) if cock.controlpressed then return cock.controlpressed ( id, k, v ) end end
love.handlers.controlreleased = function ( id, k, v ) if cock.controlreleased then return cock.controlreleased ( id, k, v ) end end
love.handlers.controlpeaked = function ( id, k, v ) if cock.controlpeaked then return cock.controlpeaked ( id, k, v ) end end
love.handlers.controlzeroed = function ( id, k, v ) if cock.controlzeroed then return cock.controlzeroed ( id, k, v ) end end
love.handlers.controlchanged = function ( id, k, v ) if cock.controlchanged then return cock.controlchanged ( id, k, v ) end end

local lk_isDown = love.keyboard.isDown
local lm_getX = love.mouse.getX
local lm_getY = love.mouse.getY
local lm_isDown = love.mouse.isDown
local lm_setPosition = love.mouse.setPosition
local lj_isDown = love.joystick.isDown
local lj_getAxis = love.joystick.getAxis
local lj_getHat = love.joystick.getHat
local lj_getNumJoysticks = love.joystick.getNumJoysticks
local lj_getNumAxes = love.joystick.getNumAxes
local lj_getNumHats = love.joystick.getNumHats
local lj_isOpen = love.joystick.isOpen
local lj_open = love.joystick.open
local lj_getName = love.joystick.getName
local le_push = love.event.push
local le_pump = love.event.pump
local lg_getWidth = love.graphics.getWidth
local lg_getHeight = love.graphics.getHeight
local table_insert = table.insert
local table_remove = table.remove
local mabs, mmin, mmax, mrand = math.abs, math.min, math.max, math.random

local l_keypressed, l_keyreleased = 0, 0
local l_mousepressed, l_mousereleased = 0, 0
local l_joystickpressed, l_joystickreleased = 0, 0
local l_controlpressed, l_controlreleased = 0, 0
local l_controlpeaked, l_controlzeroed = 0, 0
local l_controlchanged, l_update = 0, 0

local _hataliases = { [1] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "lu", ["lu"] = true }, ["ld"] = { "ld", ["ld"] = true }, ["ru"] = { "ru", ["ru"] = true }, ["rd"] = { "rd", ["rd"] = true } },
	[2] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "l", ["l"] = true }, ["ld"] = { "l", ["l"] = true }, ["ru"] = { "r", ["r"] = true }, ["rd"] = { "r", ["r"] = true } },
	[3] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "u", ["u"] = true }, ["ld"] = { "d", ["d"] = true }, ["ru"] = { "u", ["u"] = true }, ["rd"] = { "d", ["d"] = true } },
	[4] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "u", ["u"] = true }, ["ld"] = { "l", ["l"] = true }, ["ru"] = { "r", ["r"] = true }, ["rd"] = { "d", ["d"] = true } },
	[5] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "l", ["l"] = true }, ["ld"] = { "d", ["d"] = true }, ["ru"] = { "u", ["u"] = true }, ["rd"] = { "r", ["r"] = true } },
	[6] = { ["c"] = { }, ["u"] = { "u", ["u"] = true }, ["d"] = { "d", ["d"] = true }, ["l"] = { "l", ["l"] = true }, ["r"] = { "r", ["r"] = true }, ["lu"] = { "l", ["l"] = true, ["u"] = true }, ["ld"] = { "l", ["l"] = true, ["d"] = true }, ["ru"] = { "r", ["r"] = true, ["u"] = true }, ["rd"] = { "r", ["r"] = true, ["d"] = true } } }
local _hatbitfield = { "c", "u", "d", "c", "l", "lu", "ld", "l", "r", "ru", "rd", "r", "c", "u", "d", "c" }

local _lookup_hatmodes = { "8-way", "4-way vertical", "4-way horizontal", "4-way clockwise", "4-way counter-clockwise", "4-way diagonal"; ["8-way"] = 1, ["4-way vertical"] = 2, ["4-way horizontal"] = 3, ["4-way clockwise"] = 4, ["4-way counter-clockwise"] = 5, ["4-way diagonal"] = 6 }
local _lookup_devices = { "keyboard", "mouse button", "mouse axis", "joystick button", "joystick axis", "joystick hat"; ["keyboard"] = 1, ["mouse button"] = 2, ["mouse axis"] = 3, ["joystick button"] = 4, ["joystick axis"] = 5, ["joystick hat"] = 6, ["joystick hat 1"] = 6 }
local _lookup_axis = { "x", "y", "z", "r", "u", "v"; ["x"] = 1, ["y"] = 2, ["z"] = 3, ["r"] = 4, ["u"] = 5, ["v"] = 6 }  
local _lookup_modes = { [-3] = "negative whole", [-2] = "negative cutoff", [-1] = "negative", [0] = "bypass", [1] = "positive", [2] = "++", [3] = "positive cutoff"; ["positive whole"] = -3, ["--"] = -2, ["-"] = -1, ["="] = 0, ["+"] = 1, ["++"] = 2, ["+="] = 3; ["negative whole"] = -3, ["negative cutoff"] = -2, ["negative"] = 1, ["bypass"] = 0, ["positive"] = 1, ["positive cutoff"] = 2, ["positive whole"] = 3 }

-- controls capture wrappers
local function wrapper_update ( dt )
	if not cock._capture.updatelock and l_update then l_update ( dt ) end
	cock._capture.object:grab ( )
end

local function wrapper_keypressed ( key, uni )
	if not cock._capture.eventlock and l_keypressed then l_keypressed ( key, uni ) end
	cock._capture.object:grab ( nil, nil, 1, key )
end

local function wrapper_mousepressed ( x, y, key )
	if not cock._capture.eventlock and l_mousepressed then l_mousepressed ( x, y, key ) end
	cock._capture.object:grab ( nil, nil, 2, key )
end

local function wrapper_joystickpressed ( joy, key )
	if not cock._capture.eventlock and l_joystickpressed then l_joystickpressed ( joy, key ) end
	cock._capture.object:grab ( nil, nil, 4, key, nil, nil, joy )
end

local function wrapper_keyreleased ( key, uni )
	if not cock._capture.eventlock and l_keyreleased then l_keyreleased ( key, uni ) end
end

local function wrapper_mousereleased ( x, y, key )
	if not cock._capture.eventlock and l_mousereleased then l_mousereleased ( x, y, key ) end
end

local function wrapper_joystickreleased ( joy, key )
	if not cock._capture.eventlock and l_joystickreleased then l_joystickreleased ( joy, key ) end
end

local function wrapper_controlpressed ( id, k, v )
	if not cock._capture.eventlock and l_controlpressed then l_controlpressed ( id, k, v ) end
end

local function wrapper_controlreleased ( id, k, v )
	if not cock._capture.eventlock and l_controlreleased then l_controlreleased ( id, k, v ) end
end

local function wrapper_controlpeaked ( id, k, v )
	if not cock._capture.eventlock and l_controlpeaked then l_controlpeaked ( id, k, v ) end
end

local function wrapper_controlzeroed ( id, k, v )
	if not cock._capture.eventlock and l_controlzeroed then l_controlzeroed ( id, k, v ) end
end

local function wrapper_controlchanged ( id, k, v )
	if not cock._capture.eventlock and l_controlchanged then l_controlchanged ( id, k, v ) end
end

-- I could've fit that into a loop so it would look prettier, but who gives a shit about code prettines? KISS & DFWNB
local function wrapperRestore ( )
	love.update = l_update
	love.keypressed = l_keypressed
	love.keyreleased = l_keyreleased
	love.mousepressed = l_mousepressed
	love.mousereleased = l_mousereleased
	love.joystickpressed = l_joystickpressed
	love.joystickreleased = l_joystickreleased
	cock.controlpressed = l_controlpressed
	cock.controlreleased = l_controlreleased
	cock.controlpeaked = l_controlpeaked
	cock.controlzeroed = l_controlzeroed
	cock.controlchanged = l_controlchanged
end

local function wrapperSetup ( )
	l_update = love.update
	l_keypressed = love.keypressed
	l_keyreleased = love.keyreleased
	l_mousepressed = love.mousepressed
	l_mousereleased = love.mousereleased
	l_joystickpressed = love.joystickpressed
	l_joystickreleased = love.joystickreleased
	l_controlpressed = cock.controlpressed
	l_controlreleased = cock.controlreleased
	l_controlpeaked = cock.controlpeaked
	l_controlzeroed = cock.controlzeroed
	l_controlchanged = cock.controlchanged
	
	love.update = wrapper_update
	love.keypressed = wrapper_keypressed
	love.keyreleased = wrapper_keyreleased
	love.mousepressed = wrapper_mousepressed
	love.mousereleased = wrapper_mousereleased
	love.joystickpressed = wrapper_joystickpressed
	love.joystickreleased = wrapper_joystickreleased
	cock.controlpressed = wrapper_controlpressed
	cock.controlreleased = wrapper_controlreleased
	cock.controlpeaked = wrapper_controlpeaked
	cock.controlzeroed = wrapper_controlzeroed
	cock.controlchanged = wrapper_controlchanged
end

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                               BASICS                                  ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

-- Create new controls table and optionally fill it with defined control map.
-- NO COLON NOTATION
function cock.new ( id, data )
	if not id or cock._objects[ id ] then repeat id = tostring ( mrand ( 100000 ) ) until not cock._objects[ id ] end -- pick new unique ID
	local new = {
		["current"] = { }, ["previous"] = { }, ["_layout"] = { }, ["_defaults"] = { }, ["defaultOption"] = "default", ["defaultLayout"] = "default", ["id"] = id, ["mouse"] = { ["x"] = 0, ["y"] = 0, ["fx"] = 1, ["fy"] = 1, ["_x"] = 0, ["_y"] = 0 }, ["_callbacks"] = { ["any"] = false, ["controlpressed"] = false, ["controlreleased"] = false, ["controlpeaked"] = false, ["controlzeroed"] = false, ["controlchanged"] = false } 
	}
	setmetatable ( new, { ["__index"] = cock } )
	if data then new:setControls ( data ) end
	cock._objects[ id ] = new
	return new
end

-- Return object with given ID.
-- NO COLON NOTATION
function cock.find ( target )
	return cock._objects[ target ]
end

-- Delete (un-track) controls table.
function cock.delete ( self )
	if type ( self ) == "table" then self = self.id end
	cock._objects[ self ] = nil
end

-- Serialize the object.
-- NO COLON NOTATION
function cock.serialize ( delimiter, prefix )
	local _ = { }
	if not delimiter then delimiter = '\001' end
	if not prefix then prefix = "$" end
	delimiter = '\n'
	
	_[ 1 ] = prefix
	for controlKey, controlObj in pairs ( cock._objects ) do
		_[#_+1] = prefix.."object"
		_[#_+1] = controlObj.id
		_[#_+1] = controlObj.defaultOption
		_[#_+1] = controlObj.defaultLayout
		_[#_+1] = controlObj.mouse.x
		_[#_+1] = controlObj.mouse.y
		_[#_+1] = controlObj.mouse.fx
		_[#_+1] = controlObj.mouse.fy
		_[#_+1] = controlObj._callbacks.controlpressed
		_[#_+1] = controlObj._callbacks.controlreleased
		_[#_+1] = controlObj._callbacks.controlpeaked
		_[#_+1] = controlObj._callbacks.controlzeroed
		_[#_+1] = controlObj._callbacks.controlchanged
		for ii = 1, 6 do
			_[#_+1] = prefix.."bindings"
			_[#_+1] = ii
			for i = 1, #controlObj._layout[ ii ].map do
				_[#_+1] = controlObj._layout[ ii ].map[ i ]
				_[#_+1] = controlObj._layout[ ii ].key[ i ]
				_[#_+1] = controlObj._layout[ ii ].inv[ i ]
				_[#_+1] = controlObj._layout[ ii ].dlt[ i ]
				if ii > 3 then
					_[#_+1] = controlObj._layout[ ii ].joy[ i ]
					if ii == 6 then
						_[#_+1] = controlObj._layout[ ii ].hat[ i ]
					end
				end
			end
		end

		_[#_+1] = prefix.."options"
		for option, t in pairs ( controlObj._layout.options ) do
			_[#_+1] = option
		end
		
		for optionKey, optionObj in pairs ( controlObj._layout.lookup.dev ) do
			_[#_+1] = prefix.."lookups"
			_[#_+1] = optionKey
			for mapKey, mapVal in pairs ( optionObj ) do
				_[#_+1] = mapKey
				_[#_+1] = mapVal
				_[#_+1] = controlObj._layout.lookup.num[ optionKey ][ mapKey ]
			end
		end
		
		
		for defaultKey, defaultObj in pairs ( controlObj._defaults ) do
			_[#_+1] = prefix.."defaults"
			_[#_+1] = defaultKey
			for ii = 1, 6 do
				_[#_+1] = prefix.."defbindings"
				_[#_+1] = ii
				for i = 1, #defaultObj[ ii ].map do
					_[#_+1] = defaultObj[ ii ].map[ i ]
					_[#_+1] = defaultObj[ ii ].key[ i ]
					_[#_+1] = defaultObj[ ii ].inv[ i ]
					_[#_+1] = defaultObj[ ii ].dlt[ i ]
					if ii > 3 then
						_[#_+1] = defaultObj[ ii ].joy[ i ]
						if ii == 6 then
							_[#_+1] = defaultObj[ ii ].hat[ i ]
						end
					end
				end
			end
			
			_[#_+1] = prefix.."defoptions"
			for option, t in pairs ( defaultObj.options ) do
				_[#_+1] = option
			end

			for optionKey, optionObj in pairs ( defaultObj.lookup.dev ) do
				_[#_+1] = prefix.."deflookups"
				_[#_+1] = optionKey
				for mapKey, mapVal in pairs ( optionObj ) do
					_[#_+1] = mapKey
					_[#_+1] = mapVal
					_[#_+1] = defaultObj.lookup.num[ optionKey ][ mapKey ]
				end
			end
		end
	end
	
	for i = 1, #cock.joysticks do
		_[#_+1] = "$joysticks"
		_[#_+1] = cock.joysticks[ i ].name
		_[#_+1] = cock.joysticks[ i ].number
		_[#_+1] = "$deadzones"
		for j = 1, #cock.joysticks[ i ]._deadzones.thr do
			_[#_+1] = cock.joysticks[ i ]._deadzones.thr[ j ] 
		end
		_[#_+1] = "$hatremaps"
		for j = 1, #cock.joysticks[ i ]._hatremaps do
			_[#_+1] = cock.joysticks[ i ]._hatremaps[ j ][ 2 ]
			_[#_+1] = cock.joysticks[ i ]._hatremaps[ j ][ 3 ]
			_[#_+1] = cock.joysticks[ i ]._hatremaps[ j ][ 4 ]
			_[#_+1] = cock.joysticks[ i ]._hatremaps[ j ][ 5 ]
			_[#_+1] = cock.joysticks[ i ]._hatremaps[ j ].hatmode
		end
	end
	_[#_+1] = "$EOF"
	-- check integrity
	--[[
	for k, v in pairs ( _ ) do
		if string.match ( v, delimiter ) then return nil end
	end
	--]]
	
	local l = table.concat ( _, delimiter )
	print ( l )
	return l
end

-- Deserialize the object.
-- NO COLON NOTATION
--[[
function deserialize ( data )
	local prefix = string.sub ( data, 1, 1 )
	local delimiter = string.sub ( data, 2, 1 )
	local raw = { }
	
	local c = 2
	local u = 1

	for k in string.gmatch ( data, "[^%" .. ( delimiter == '\000' and 'z' or delimiter ) .. "]" ) do raw [ #raw + 1 ] = k end
	
	while c < #raw do
		if raw[ c ] == prefix.."object" then
			_.objects[ u ].id = raw[ c ]
			_.objects[ u ].defaultOption = raw[ c + 1 ]
			_.objects[ u ].defaultLayout = raw[ c + 2 ]
			_.objects[ u ].mouse.x = tonumber ( raw[ c + 3 ] )
			_.objects[ u ].mouse.y = tonumber ( raw[ c + 4 ] )
			_.objects[ u ].mouse.fx = tonumber ( raw[ c + 5 ] )
			_.objects[ u ].mouse.fy = tonumber ( raw[ c + 6 ] ) 
			_.objects[ u ]._callbacks.controlpressed = raw[ c + 7 ] == "true" and true or false
			_.objects[ u ]._callbacks.controlreleased = raw[ c + 8 ] == "true" and true or false
			_.objects[ u ]._callbacks.controlpeaked = raw[ c + 9 ] == "true" and true or false
			_.objects[ u ]._callbacks.controlzeroed = raw[ c + 10 ] == "true" and true or false
			_.objects[ u ]._callbacks.controlchanged = raw[ c + 11 ] == "true" and true or false
			c = c + 12
			while raw[ c ] == prefix.."bindings" do
				local d = raw[ c + 1 ]
				if raw[ c + 2 ] ~= prefix.."bindings" then
					_objects[ u ]._layout[ d ].map = raw[ c + 2 ]
					_objects[ u ]._layout[ d ].key = ( dev > 2 and dev < 6 ) and tonumber ( raw[ c + 3 ] ) or raw[ c + 3 ]
					_objects[ u ]._layout[ d ].inv = tonumber ( raw[ c + 4 ] )
					_objects[ u ]._layout[ d ].dlt = tonumber ( raw[ c + 5 ] )
					if d > 3 then
						_objects[ u ]._layout[ d ].joy = tonumber ( raw[ c + 6 ] )
						if d == 6 then
							_objects[ u ]._layout[ d ].hat = tonumber ( raw[ c + 7 ] )
							c = c + 8
						else
							c = c + 7
						end
					else
						c = c + 6
					end
				end
			end
			if raw[ c ] == prefix.."options" do
				while raw[ c ] ~= prefix..
		end
		
	end
	
	while raw[ c ] ~=  do
		c = c + 1 
		
	end
	
	for i, s in ipairs ( raw ) do
	end
end
]]
-- Fill the controls table with control map; will overwrite currently defined map, but will not erase what's not overlapped.
-- { default1 = { forward = { option1 = { dev, key, inv, dlt }, option2 = { }, etc. }, backwards = { }, etc. }, default2 = { }, etc. }
function cock.setControls ( self, data )
	for defKey, defVal in pairs ( data ) do
		if not self._defaults[ defKey ] then self._defaults[ defKey ] = { [1] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["raw"] = { } }, [2] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["raw"] = { } }, [3] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["raw"] = { } }, [4] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["joy"] = { }, ["raw"] = { } }, [5] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["joy"] = { }, ["raw"] = { } }, [6] = { ["key"] = { }, ["map"] = { }, ["inv"] = { }, ["dlt"] = { }, ["joy"] = { }, ["hat"] = { }, ["raw"] = { } }, ["lookup"] = { ["dev"] = { }, ["num"] = { } }, ["options"] = { } } end
		local slot = self._defaults[ defKey ]
		for mapKey, mapVal in pairs ( defVal ) do
			if not self.current[ mapKey ] then
				self.current[ mapKey ] = 0.0
				self.previous[ mapKey ] = 0.0
			end
			for optKey, optVal in pairs ( mapVal ) do
				slot.options[ optKey ] = true
				
				--if not self.defaults[ defKey ][ optKey ] then self.defaults[ defKey ][ optKey ] = { map = { }, invmap = { }, dev = { }, key = { }, inv = { }, dlt = { }, _did = { }, _raw = { } } end
				local dev, key, inv, dlt, hat = optVal[ 1 ], optVal[ 2 ], optVal[ 3 ] or 2, optVal[ 4 ] or 0, 0
				
				-- convert literal names to digital names
				if type ( dev ) == "string" then local d = _lookup_devices[ dev ]; if not d then d = tonumber ( dev:sub ( 14 ) ) + 5; _lookup_devices[ dev ] = d; _lookup_devices[ d ] = dev end dev = d end
				if ( dev == 3 or dev == 5 ) and type ( key ) == "string" then local a = _lookup_axis [ key ]; if not a then a = tonumber ( key ); _lookup_axis[ key ] = a; _lookup_axis[ a ] = key end key = a end
				if type ( inv ) == "string" then inv = _lookup_modes[ inv ] end
				if type ( dlt ) == "string" then dlt = _lookup_modes[ dlt ] end
				
				if dev > 5 then hat = dev - 5; dev = 6 end
				table_insert ( slot[ dev ].key, key )
				table_insert ( slot[ dev ].map, mapKey )
				table_insert ( slot[ dev ].inv, inv )
				table_insert ( slot[ dev ].dlt, dlt )
				table_insert ( slot[ dev ].raw, 0.0 )
				if dev > 3 then
					table_insert ( slot[ dev ].joy, 1 )
					if dev == 6 then
						table_insert ( slot[ dev ].hat, hat )
					end
				end
				
				if not slot.lookup.dev[ optKey ] then slot.lookup.dev[ optKey ] = { }; slot.lookup.num[ optKey ] = { } end
				slot.lookup.dev[ optKey ][ mapKey ] = dev 
				slot.lookup.num[ optKey ][ mapKey ] = #slot[ dev ].key
			--[[
			
			layout = { 
				["keyboard"] = { 
					key = { "w", "s", "a", "d" }, 
					map = { "up", "down", "left", "right" }, 
					inv = { 2, 2, 2, 2 }, 
					dlt = { 0, 0, 0, 0 } }, 
				joystickhat = { 
					key = { "u", "d", "l", "r" }, 
					map = { "up", "down", "left", "right" }, 
					inv = { 2, 2, 2, 2 }, 
					dlt = { 0, 0, 0, 0 }, 
					hat = { 1, 1, 1, 1 }, 
					joy = { 1, 1, 1, 1 } }

			layouts = { 
				devs = { 
					option1 = { "map" = dev }, option2 = { "map" = dev }, 
					nums = { option1 = { "map" = num } } }
				--]]
			end
		end
	end
end

-- Set controls layout to specified default layout.
function cock.setDefault ( self, default )
	if not default then default = self.defaultLayout end
	self._layout = self._defaults[ default ]
end

-- Set controls layout to XBox360 controller layout.
function cock.setDefaultXBox360 ( self, override, d )
	if love._os ~= "Windows" then return 0 end -- Sorry, no eeks-bawkz for Linux and Mac
	
	if not override then override = "XBox360" end
	if not self.layout[ override ] then self.layout[ override ] = { } end
	if not d then d = 1 end
	if not cock.joysticks[ d ] then d = cock.addJoystick ( 1 ) end
	
	self.current = { ["A"] = 0.0, ["B"] = 0.0, ["X"] = 0.0, ["Y"] = 0.0, ["LB"] = 0.0, ["RB"] = 0.0, ["Back"] = 0.0, ["Start"] = 0.0, ["XBox"] = 0.0, ["LS"] = 0.0, ["RS"] = 0.0, ["LX"] = 0.0, ["LY"] = 0.0, ["LT"] = 0.0, ["RT"] = 0.0, ["RX"] = 0.0, ["RY"] = 0.0, ["u"] = 0.0, ["d"] = 0.0, ["l"] = 0.0, ["r"] = 0.0, ["lu"] = 0.0, ["ld"] = 0.0, ["ru"] = 0.0, ["rd"] = 0.0 }
	self.previous ={ ["A"] = 0.0, ["B"] = 0.0, ["X"] = 0.0, ["Y"] = 0.0, ["LB"] = 0.0, ["RB"] = 0.0, ["Back"] = 0.0, ["Start"] = 0.0, ["XBox"] = 0.0, ["LS"] = 0.0, ["RS"] = 0.0, ["LX"] = 0.0, ["LY"] = 0.0, ["LT"] = 0.0, ["RT"] = 0.0, ["RX"] = 0.0, ["RY"] = 0.0, ["u"] = 0.0, ["d"] = 0.0, ["l"] = 0.0, ["r"] = 0.0, ["lu"] = 0.0, ["ld"] = 0.0, ["ru"] = 0.0, ["rd"] = 0.0 }
	
	self._layout.options[ override ] = true
	
	self._layout.lookup.dev[ override ] = { ["A"] = 4, ["B"] = 4, ["X"] = 4, ["Y"] = 4, ["LB"] = 4, ["RB"] = 4, ["Back"] = 4, ["Start"] = 4, ["XBox"] = 4, ["LS"] = 4, ["RS"] = 4, ["LX"] = 5, ["LY"] = 5, ["LT"] = 5, ["RT"] = 5, ["RX"] = 5, ["RY"] = 5, ["u"] = 6, ["d"] = 6, ["l"] = 6, ["r"] = 6, ["lu"] = 6, ["ld"] = 6, ["ru"] = 6, ["rd"] = 6 }
	self._layout.lookup.num[ override ] = { ["A"] = 1, ["B"] = 2, ["X"] = 3, ["Y"] = 4, ["LB"] = 5, ["RB"] = 6, ["Back"] = 7, ["Start"] = 8, ["XBox"] = 9, ["LS"] = 10, ["RS"] = 11, ["LX"] = 1, ["LY"] = 2, ["LT"] = 3, ["RT"] = 4, ["RX"] = 5, ["RY"] = 6, ["u"] = 1, ["d"] = 2, ["l"] = 3, ["r"] = 4, ["lu"] = 5, ["ld"] = 6, ["ru"] = 7, ["rd"] = 8 }
	
	self._layout[ 4 ] = { ["map"] = { "A", "B", "X", "Y", "LB", "RB", "Back", "Start", "XBox", "LS", "RS" }, ["inv"] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 }, ["dlt"] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, ["raw"] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 }, ["joy"] = { d, d, d, d, d, d, d, d, d, d, d } }
	self._layout[ 5 ] = { ["map"] = { "LX", "LY", "LT", "RT", "RX", "RY" }, ["inv"] = { 1, 1, 3, 3, 1, 1 }, ["dlt"] = { 0, 0, 0, 0, 0, 0 }, ["raw"] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 }, ["joy"] = { d, d, d, d, d, d } }
	self._layout[ 6 ] = { ["map"] = { "u", "d", "l", "r", "lu", "ld", "ru", "rd" }, ["key"] = { "u", "d", "l", "r", "lu", "ld", "ru", "rd" }, ["inv"] = { 2, 2, 2, 2, 2, 2, 2, 2 }, ["dlt"] = { 0, 0, 0, 0, 0, 0, 0, 0 }, ["raw"] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 }, ["joy"] = { d, d, d, d, d, d, d, d }, ["hat"] = { 1, 1, 1, 1, 1, 1, 1, 1 } }
	
	if love._os == "Windows" then
		self._layout[ 4 ][ "key" ] = { 1, 2, 3, 4, 5, 6, 7, 8, 12, 9, 10 }
		self._layout[ 5 ][ "key" ] = { 1, 2, 3, 3, 5, 4 }
		self._layout[ 5 ][ "inv" ][ 3 ] = 2
		self._layout[ 5 ][ "inv" ][ 4 ] = -2
	elseif love._os == "OS X" then
		self._layout[ 4 ][ "key" ] = { 12, 13, 14, 15, 9, 10, 5, 6, 11, 7, 8 }
		self._layout[ 5 ][ "key" ] = { 1, 2, 5, 6, 3, 4 }
		self.joysticks[ d ]._hatremaps[ 1 ] = { "c", 1, 2, 3, 4; ["hatmode"] = 1 }
	else -- Linux and other
		self._layout[ 4 ][ "key" ] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }
		self._layout[ 5 ][ "key" ] = { 1, 2, 6, 5, 3, 4 }
		--self.joysticks[ d ]._hatremaps[ 1 ] = { "c", 14, 15, 12, 13; ["hatmode"] = 1 }
	end
	return d
end

-- Add controls option.
function cock.addOption ( self, option )
	if not option then repeat option = tostring ( mrand ( 100000 ) ) until not self._layout.options[ option ] end
	self._layout.options[ option ] = true
	return option
end

-- Delete controls option (will erase all binds).
function cock.deleteOption ( self, option )
	for k, v in pairs ( self._layout.lookup.dev[ option ] ) do
		cock.unbind ( self, k, option )
	end
	self._layout.options[ option ] = nil
end

-- Find next non-occupied option for given map.
function cock.getEmptyOption ( self, map )
	local d = self._layout.lookup.dev
	for k, v in pairs ( self._layout.options ) do
		if not d[ k ] then return k end
	end
	return nil
end

-- Bind map.
-- func ( ... ) - bind specified data ( defaults: inv = 2, dlt = 0, val = 1, did = 1 )
-- func ( longarg ) - bind by data from longarg string
function cock.bind ( self, map, option, dev, key, inv, dlt, val, did )
	if not option then 
		local t1, t2, t3, t4, t5, t6, t7 = cock.explodeCapturedData ( map )
		if t7 then
			map = t1
			option = t2
			dev = t3
			key = t4
			inv = t5
			val = t6
			did = t7
		else
			option = self.defaultOption
		end
	end

	if not val then val = 0.0 end
	
	-- if not self._layout.options[ option ] then return end -- bind to unexisting option failsafe
	
	if type ( dev ) == "string" then local d = _lookup_devices[ dev ]; if not d then d = tonumber ( dev:sub ( 14 ) ) + 5; _lookup_devices[ dev ] = d; _lookup_devices[ d ] = dev end dev = d end
	if ( dev == 3 or dev == 5 ) and type ( key ) == "string" then local a = _lookup_axis [ key ]; if not a then a = tonumber ( key ); _lookup_axis[ key ] = a; _lookup_axis[ a ] = key end key = a end
	if type ( inv ) == "string" then inv = _lookup_modes[ inv ] end
	if type ( dlt ) == "string" then dlt = _lookup_modes[ dlt ] end
	if type ( did ) == "string" then did = self.joysticks[ did ] end
	
	self.current[ map ] = val
	self.previous[ map ] = val
	
	local hat, num = 0, self._layout.lookup.num[ option ][ map ]
	if dev > 5 then hat = dev - 5; dev = 6 end
	local d = self._layout[ dev ]
	if not num then num = #d.key + 1 end -- reuse old slot if possible
	
	
	d.key[ num ] = key
	d.map[ num ] = map
	d.inv[ num ] = inv or 2
	d.dlt[ num ] = dlt or 0
	d.raw[ num ] = val or 1.0
	if dev > 3 then
		d.joy[ num ] = did
		if dev == 6 then
			d.hat[ num ] = hat
		end
	end
	
	d = self._layout.lookup
	if not d.dev[ option ] then d.dev[ option ] = { }; d.num[ option ] = { } end
	d.dev[ option ][ map ] = dev
	d.num[ option ][ map ] = num
end

-- Delete input key and device from layout for specified map.
function cock.unbind ( self, map, option )
	if not option then option = self.defaultOption end
	
	local dev, num = self._layout.lookup.dev[ option ][ map ], self._layout.lookup.num[ option ][ map ]
	local sld = self._layout[ dev ]
	
	table_remove ( sld.key, num )
	table_remove ( sld.map, num )
	table_remove ( sld.inv, num )
	table_remove ( sld.dlt, num )
	table_remove ( sld._raw, num )
	if dev > 3 then
		table_remove ( sld.joy, num )
		if dev == 6 then
			table_remove ( sld.hat, num )
		end
	end
	
	sld = self._layout.lookup.num[ option ]  -- variable reuse (see loop below)
	sld[ map ] = nil
	self._layout.lookup.dev[ option ][ map ] = nil
	
	for k, v in pairs ( sld ) do
		if v > num then sld[ k ] = v - 1 end
	end
end

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                                 MOUSE                                 ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

-- Set mouse offset.
function cock.setMouseOffset ( self, x, y )
	self.mouse.x = x or self.mouse.x
	self.mouse.y = y or self.mouse.y
end

-- Get mouse offset.
function cock.getMouseOffset ( self )
	return self.mouse.x, self.mouse.y
end

-- Set mouse multiplication factor.
function cock.setMouseFactor ( self, x, y )
	self.mouse.fx = x or self.mouse.fx
	self.mouse.fy = y or self.mouse.fy 
end

-- Get mouse multiplication factor.
function cock.getMouseFactor ( self )
	return self.mouse.fx, self.mouse.fy
end

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                               JOYSTICK                                ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

-- Add and set up new joystick to joysticks list.
-- NO COLON NOTATION
function cock.addJoystick ( number )
	if not number then number = 1 end
	local isdummy = lj_getNumJoysticks ( ) < number and true or false
	local joyname = isdummy and "None" or ( lj_getName ( number ) .. " (" .. number .. ")" )
	local joynum = 0
	
	
	if isdummy then number = 0 end
	for k, v in ipairs ( cock.joysticks ) do if v == nil then joynum = k end end -- find unused slot
	if joynum == 0 then joynum = #cock.joysticks + 1 end
	
	cock.joysticks[ joyname ] = joynum
	cock.joysticks[ joynum ] = { ["name"] = joyname, ["number"] = number, ["_deadzones"] = { ["thr"] = { }, ["amp"] = { } }, ["_hatremaps"] = { } }
	if not isdummy then -- dummy joysticks don't have hats
		local hatremaps = cock.joysticks[ joynum ]._hatremaps
		for i = 1, lj_getNumHats ( number ) do
			hatremaps[ i ] = { "c", false, 0, 0, 0; ["hatmode"] = 1 } -- set up joystick hats
		end
	else
		cock.joysticks[ joynum ].dummy = true 
	end
	
	return joynum
end

-- Delete joystick.
-- NO COLON NOTATION
function cock.deleteJoystick ( number )
	local name
	if type ( number ) == "string" then
		name = number
		number = cock.joysticks[ number ] 
	else 
		name = cock.joysticks[ number ].name 
	end
	
	cock.joysticks[ number ] = nil -- leaves a gap hole
	cock.joysticks[ name ] = nil
end

-- Set joystick hat mode by either number or literal value.
-- NO COLON NOTATION
function cock.setJoystickHatMode ( joystick, hat, hatmode )
	if not joystick then joystick = 1 elseif type ( joystick ) == "string" then joystick = cock.joysticks[ joystick ] end
	if cock.joysticks[ joystick ].dummy then return end -- do not service dummies
	if not hat then hat = 1 elseif type ( hat ) == "string" then local d = _lookup_devices[ hat ]; if not d then d = tonumber ( hat:sub ( 14 ) ); _lookup_devices[ d + 5 ] = hat; _lookup_devices[ hat ] = d + 5 end hat = d end
	if not hatmode then hatmode = 1 elseif type ( hatmode ) == "string" then hatmode = _lookup_hatmodes[ hatmode ] end

	cock.joysticks[ joystick ]._hatremaps[ hat ].hatmode = hatmode
end

-- Get literal joystick hat mode.
-- NO COLON NOTATION
function cock.getJoystickHatMode ( joystick, hat )
	if not joystick then joystick = 1 elseif type ( joystick ) == "string" then joystick = cock.joysticks[ joystick ] end
	if cock.joysticks[ joystick ].dummy then return 1 end -- do not service dummies
	if not hat then hat = 1 elseif type ( hat ) == "string" then local d = _lookup_devices[ hat ]; if not d then d = tonumber ( hat:sub ( 14 ) ); _lookup_devices[ d + 5 ] = hat; _lookup_devices[ hat ] = d + 5 end hat = d end
	
	return _lookup_hatmodes[ cock.joysticks[ joystick ]._hatremaps[ hat ].hatmode ]
end

-- Set joystick deadzone.
-- NO COLON NOTATION
-- func ( self, joy, true, thr ) : sets deadzone to all axis
function cock.setJoystickDeadzone ( joystick, axis, threshold )
	if not joystick then joystick = 1 elseif type ( joystick ) == "string" then joystick = cock.joysticks[ joystick ] end
	if cock.joysticks[ joystick ].dummy then return end -- do not service dummies
	
	--if joystick and cock.joysticks[ joystick ] then -- unnecessary failsafe
		if axis == true then 
			axis = 1 / ( 1 - threshold ) -- just reused a variable, that ain't crime
			for i = 1, lj_getNumAxes ( joystick ) do --love.joystick.getAxisCount since 0.9.0
				cock.joysticks[ joystick ]._deadzones.thr[ i ] = threshold
				cock.joysticks[ joystick ]._deadzones.amp[ i ] = axis
			end
		else
			if type ( axis ) == "string" then local a = _lookup_axis[ axis ]; if not a then a = tonumber ( axis ); _lookup_axis[ axis ] = a; _lookup_axis[ a ] = axis end axis = a end
			cock.joysticks[ joystick ]._deadzones.thr[ axis ] = threshold 
			cock.joysticks[ joystick ]._deadzones.amp[ axis ] = 1 / ( 1 - threshold )
		end
	--end
end

-- Get joystick deadzone.
-- NO COLON NOTATION
function cock.getJoystickDeadzone ( joystick, axis )
	if not joystick then joystick = 1 elseif type ( joystick ) == "string" then joystick = cock.joysticks[ joystick ] end
	if cock.joysticks[ joystick ].dummy then return 0.0 end -- do not service dummies
	if not axis then axis = 1 elseif type ( axis ) == "string" then local a = _lookup_axis [ key ]; if not a then a = tonumber ( key ); _lookup_axis[ key ] = a; _lookup_axis[ a ] = key end key = a end
	
	return cock.joysticks[ joystick ]._deadzones.thr[ axis ]
end

-- Map (exactly) 4 joystick buttons to act like joystick hat. 
-- NO COLON NOTATION
function cock.remapJoystickHat ( joystick, hat, u, d, l, r )
	if not joystick then joystick = 1 elseif type ( joystick ) == "string" then joystick = cock.joysticks[ joystick ] end
	if cock.joysticks[ joystick ].dummy then return end -- do not service dummies
	if not hat then hat = 1 elseif type ( hat ) == "string" then local d = _lookup_devices[ hat ]; if not d then d = tonumber ( hat:sub ( 14 ) ); _lookup_devices[ d + 5 ] = hat; _lookup_devices[ hat ] = d + 5 end hat = d end
	
	--if joystick and self.joysticks[ joystick ] then
		local remaps = cock.joysticks[ joystick ]._hatremaps[ hat ]
		if not remaps then -- one may add virtual hat
			cock.joysticks[ joystick ]._hatremaps[ hat ] = { "c", false, 0, 0, 0; ["hatmode"] = 1 } 
			remaps = cock.joysticks[ joystick ]._hatremaps[ hat ]
		end
		if not u and not d and not l and not r then 
			remaps[ 2 ] = false
			remaps[ 3 ] = 0
			remaps[ 4 ] = 0
			remaps[ 5 ] = 0
			return
		end
		remaps[ 2 ] = u or remaps[ 2 ]
		remaps[ 3 ] = d or remaps[ 3 ]
		remaps[ 4 ] = l or remaps[ 4 ]
		remaps[ 5 ] = r or remaps[ 5 ] 
	--end
end

-- Resolve joystick un- and re-plugging.
-- NO COLON NOTATION
function cock.reloadJoysticks ( ) 
	local taken = { }
	-- love.joystick.reload ( ) since 0.9.0
	for i = 1, #cock.joysticks do
		local joy = cock.joysticks[ i ]
		local name
		if joy.dummy then name = "" elseif joy.fallback then name = joy.fallback.name else name = joy.name end -- use fallback name
		name = name:gsub ( "%s%(%d+%)$", "" ) -- remove trailing joystick number from the name

		joy.number = 0
		for j = 1, lj_getNumJoysticks ( ) do  -- love.joystick.getJoystickCount since 0.9.0
			if not taken[ j ] then -- multiple same joysticks, like multiple XBox360 controllers - ignore what's taken
				if lj_getName ( j ) == name then
					if joy.fallback then -- restore backed up data
						cock.joysticks[ i ] = joy.fallback 
						joy = self.joysticks[ i ] 
					end
					joy.number = j -- patch up to new data
					joy.name = name .. " (" .. j .. ")"
					cock.joysticks[ joy.name ] = i
					taken[ j ] = true
					break 
				end
			end
		end
	end
	
	for i = 1, #cock.joysticks do -- look for unresolved joysticks
		local joy = cock.joysicks[ i ]
		if joy.number == 0 then
			for j = 1, lj_getNumJoysticks ( ) do -- pick first unused joystick
				if not taken[ j ] then
					if not joy.fallback then
						if not joy.dummy then joy.fallback = joy end -- save original data (if not dummy)
						joy.number = j
						joy.name = lj_getName ( j ) .. " (" .. j .. ")"
						joy._hatremaps = { }
						for z = 1, lj_getNumHats ( j ) do
							joy._hatremaps[ 1 ] = { "c", false, 0, 0, 0; ["hatmode"] = 1 }
						end
					end
				end
			end
		end
		-- if joystick is still unresolved by this point, then just keep the reference
	end 
end
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                               HANDLING                                ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

-- Set callbacks field.
function cock.setCallbacks ( self, pressed, released, peaked, zeroed, changed )
	self = self._callbacks
	if type ( pressed ) == "string" and type ( released ) == "boolean" then
		self[ pressed ] = released
		self.any = true
		return
	end
	self.controlpressed = pressed or self.controlpressed
	self.controlreleased = released or self.controlreleased
	self.controlpeaked = peaked or self.controlpeaked
	self.controlzeroed = zeroed or self.controlzeroed
	self.controlchanged = changed or self.controlchanged
	
	self.any = ( self.controlpressed or self.controlreleased or self.controlpeaked or self.controlzeroed or self.controlchanged ) and true or false
end

-- Enable "input capture" mode.
function cock.setCapture ( self, map, option, eventlock, updatelock, nomouse, callback )
	wrapperSetup ( )
	if nomouse then
		cock._capture.mouse = false
	else
		cock._capture.mouse = true
		self.mouse._x = lm_getX ( )
		self.mouse._y = lm_getY ( )
		lm_setPosition ( lg_getWidth ( ) / 2, lg_getHeight ( ) / 2 ) 
		le_pump ( ) -- kludge for odd behavior with failed mouse repositioning 
	end
	cock._capture.object = self
	cock._capture.map = map
	cock._capture.option = option or self.defaultOption
	cock._capture.eventlock = eventlock and true or false
	cock._capture.updatelock = updatelock and true or false
	cock._capture.callback = ( callback == nil ) and true or callback
end

-- Return capture state.
-- No COLON NOTATION
function cock.getCapture ( )
	return cock._capture.object
end

-- Cancel the capture mode and restore all temporary values back.
-- NO COLON NOTATION
function cock.cancelCapture ( )
	wrapperRestore ( )
	if cock._capture.mouse then lm_setPosition ( cock._capture.object.mouse._x, cock._capture.object.mouse._y ) end
	cock._capture.object = false
end

-- Update all registered control objects.
-- NO COLON NOTATION
function cock.updateAll ( )
	for i = 1, #cock.joysticks do -- update hats positions
		local jnum, jhrem = cock.joysticks[ i ].number, cock.joysticks[ i ]._hatremaps
		for j = 1, #jhrem do -- go through every hat
			local jh = jhrem[ j ]
			if jh[ 2 ] then -- remapped hat is computed via bitfield
				jh[ 1 ] = _hatbitfield[ ( lj_isDown ( jnum, jh[ 2 ] ) and 2 or 1 ) + ( lj_isDown ( jnum, jh[ 3 ] ) and 2 or 0 ) + ( lj_isDown ( jnum, jh[ 4 ] ) and 4 or 0 ) + ( lj_isDown ( jnum, jh[ 5 ] ) and 8 or 0 ) ]
			else
				jh[ 1 ] = lj_getHat ( jnum, j )
			end
		end
	end
	
	for k, v in pairs ( cock._objects ) do
		cock.update ( v )
	end
end

-- Update all control states. 
function cock.update ( self )
	local curr, prev, mouse = self.current, self.previous, self.mouse
	
	for k, v in pairs ( curr ) do 
		curr[ k ] = 0.0
	end
	
	-- the code is pretty bulky - a trade for features; I did my best to cut it down
	local R = 0
	local T = self._layout[ 1 ]
	local S, F, m, k, i, a, r, j, h; 
	for I = 1, #T.map do
		m, a, r = T.map[ I ], T.dlt[ I ], T.raw[ I ]; R = lk_isDown ( T.key[ I ] ) and ( T.inv[ I ] < 0 and 0.0 or 1.0 ) or ( T.inv[ I ] < 0 and 1.0 or 0.0 ); 
		if a ~= 0 then T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end; end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end
	end
	
	T = self._layout[ 2 ]
	for I = 1, #T.map do
		m, a, r = T.map[ I ], T.dlt[ I ], T.raw[ I ]; R = lm_isDown ( T.key[ I ] ) and ( T.inv[ I ] < 0 and 0.0 or 1.0 ) or ( T.inv[ I ] < 0 and 1.0 or 0.0 ); 
		if a ~= 0 then T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end; end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end
	end
	
	T = self._layout[ 3 ]
	for I = 1, #T.map do
		m, i, a, r = T.map[ I ], T.inv[ I ], T.dlt[ I ], T.raw[ I ]; R = ( T.key[ I ] == 1 and ( mouse.x - lm_getX ( ) ) * mouse.fx or ( mouse.y - lm_getY ( ) ) * mouse.fy ) * ( i < 0 and -1 or 1 ); 
		if a == 0 then if i == 2 or i == -2 then R = mmax ( R, 0.0 ) end else T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end; end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end
	end
	
	T = self._layout[ 4 ]
	for I = 1, #T.map do
		m, a, r, j = T.map[ I ], T.dlt[ I ], T.raw[ I ], cock.joysticks[ T.joy[ I ] ]; if j and j.number > 0 then R = lj_isDown ( j.number, T.key[ I ] ) and ( T.inv[ I ] < 0 and 0.0 or 1.0 ) or ( T.inv[ I ] < 0 and 1.0 or 0.0 ); 
		if a ~= 0 then T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end; end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end; end 
	end
	
	T = self._layout[ 5 ]
	for I = 1, #T.map do
		m, k, i, a, r, j = T.map[ I ], T.key[ I ], T.inv[ I ], T.dlt[ I ], T.raw[ I ], cock.joysticks[ T.joy[ I ] ]; 
		if j and j.number > 0 then R = lj_getAxis ( j.number, k ) * ( i < 0 and -1.0 or 1.0 ); if i == 3 or i == -3 then R = ( R + 1.0 ) / 2 end
		local t = j._deadzones.thr[ k ]; if a == 0 and t then if R > 0 then S, F = -1.0, mmax else S, F = 1.0, mmin end R = F ( 0.0, ( R + t * S ) * j._deadzones.amp[ k ] ) end
		if a == 0 then if i == 2 or i == -2 then R = mmax ( R, 0.0 ) end else T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end; end
	end
	
	T = self._layout[ 6 ]
	for I = 1, #T.map do
		m, a, r, j, h = T.map[ I ], T.dlt[ I ], T.raw[ I ], cock.joysticks[ T.joy[ I ] ], T.hat[ I ]; if j and j.number > 0 and j._hatremaps[ h ] then h = j._hatremaps[ h ];
		R = _hataliases[ h.hatmode ][ h[ 1 ] ][ T.key[ I ] ] and ( T.inv[ I ] < 0 and 0.0 or 1.0 ) or ( T.inv[ I ] < 0 and 1.0 or 0.0 )
		if a ~= 0 then T.raw[ I ] = R; if a == 1 or ( a == 2 and R > r ) then R = R - r elseif a == -1 or ( a == -2 and R < r ) then R = r - R else R = 0.0 end; end;
		if R > 0 then S, F = 1.0, mmax else S, F = -1.0, mmin end; if ( curr[ m ] > 0 ) ~= ( R > 0 ) then curr[ m ] = curr[ m ] + R * S else curr[ m ] = F ( curr[ m ], R ) end; end
	end
	
	T = self._callbacks
	if T.any then
		for k, v in pairs ( curr ) do -- push events
			R = prev[ k ]
			if T.controlpressed and ( ( v > 0.5 and R <= 0.5 ) or ( v < -0.5 and R >= -0.5 ) ) then
				le_push ( "controlpressed", self.id, k, v )
			elseif T.controlreleased and ( ( v <= 0.5 and R > 0.5 ) or ( v > -0.5 and R <= -0.5 ) )  then
				le_push ( "controlreleased", self.id, k, v )
			end
			if T.controlpeaked and ( ( v >= 1.0 and v > R ) or ( v <= -1.0 and v < R ) ) then
				le_push ( "controlpeaked", self.id, k, v )
			elseif T.controlzeroed and v == 0.0 and v ~= R then
				le_push ( "controlzeroed", self.id, k, v )
			end
			if T.controlchanged and v ~= prev[ k ] then
				le_push ( "controlchanged", self.id, k, v )
			end
			prev[ k ] = v
		end
	end
end

-- Grab the input device and key. Returns false if nothing was grabbed.
function cock.grab ( self, map, option, dev, key, inv, val, did )
	if not map then map = cock._capture.map end
	if not option then option = cock._capture.option end
	
	if type ( dev ) == "string" then local d = _lookup_devices[ dev ]; if not d then d = tonumber ( dev:sub ( 14 ) ) + 5; _lookup_devices[ dev ] = d; _lookup_devices[ d ] = dev else dev = d end end
	if ( dev == 3 or dev == 5 ) and type ( key ) == "string" then local a = _lookup_axis [ key ]; if not a then a = tonumber ( key ); _lookup_axis[ key ] = a; _lookup_axis[ a ] = key end end
	if type ( inv ) == "string" then inv = _lookup_modes[ inv ] end
	if type ( did ) == "string" then did = self.joysticks[ did ] end
	
	if dev == 4 and key and did then -- possibly remapped joystick hat
		local n = self.joysticks[ did ].number
		for i, v in pairs ( self.joysticks[ did ]._hatremaps ) do
			if v[ 2 ] == key or v[ 3 ] == key or v[ 4 ] == key or v[ 5 ] == key then
				local k = _hataliases[ v.hatmode ][ _hatbitfield[ ( lj_isDown ( n, v[ 2 ] ) and 2 or 1 ) + ( lj_isDown ( n, v[ 3 ] ) and 2 or 0 ) + ( lj_isDown ( n, v[ 4 ] ) and 4 or 0 ) + ( lj_isDown ( n, v[ 5 ] ) and 8 or 0 ) ] ][ 1 ]
				if k then -- just because related key is pressed does not guarantees that there's meaningful hat input
					key = k
					dev = i + 5
					break
				end
			end
		end
	end
	
	if not key then
		if cock._capture.mouse and ( not dev or dev == 3 ) then -- capture mouse
			local mdx, mdy = lm_getX ( ) - lg_getWidth ( ) / 2, lm_getY ( ) - lg_getHeight ( ) / 2
			if mabs ( mdx ) > 50 and mabs ( mdx ) > mabs ( mdy ) then
				if not dev then dev = 3 end
				key = 1
				val = mabs ( mdx )
				inv = mdx > 0 and 1 or -1
				dev = 3
			elseif mabs ( mdy ) > 50 and mabs ( mdy ) > mabs ( mdx ) then
				if not dev then dev = 3 end
				key = 2
				val = mabs ( mdy )
				inv = mdy > 0 and 1 or -1
				dev = 3
			end
		end
		if not dev or dev == 5 then -- capture joystick axis
			for i = 1, lj_getNumJoysticks ( ) do -- love.joystick.getJoystickCount ( i ) since 0.9.0
				for j = 1, lj_getNumAxes ( i ) do -- love.joystick.getAxisCount ( num ) since 0.9.0
					local a = lj_getAxis ( i, j )
					if mabs ( a ) > 0.5 then
						local k = 0
						key = j
						val = mabs ( a )
						inv = a > 0.0 and 1 or -1
						dev = 5
						
						for z = 1, #self.joysticks do
							if self.joysticks[ z ].number == i then did = i; break end
						end
						if not did then
							did = self:addJoystick ( i )
						end
						break
					end
				end
			end
		end
		if not dev or dev > 5 then -- capture joystick hat (tricky)
			if not dev then
				for i = 1, lj_getNumJoysticks ( ) do -- love.joystick.getJoystickCount ( ) since 0.9.0
					local dd = did
					if not dd then
						for z = 1, #self.joysticks do -- find joystick (if not specified)
							if self.joysticks[ z ].number == i then dd = i; break end
						end
					end
					
					if dd then -- joystick exists
						for k, v in pairs ( self.joysticks[ dd ]._hatremaps ) do
							if v[ 2 ] == false then -- ignore remapped hats, they're resolved elsewhere
								key = _hataliases[ v.hatmode ][ lj_getHat ( i, k ) ][ 1 ] -- this table conveniently contains "nil" value for "c" key
								if key then
									dev = k + 5
									did = dd
									break
								end
							end
						end
					else -- joystick does not exists
						for j = 1, lj_getNumHats ( i ) do -- love.joystick.getHatCount ( i ) since 0.9.0
							key = _hataliases[ 1 ][ lj_getHat ( i, j ) ][ 1 ] -- default to 8-way
							if key then 
								dev = j + 5
								did = self:addJoystick ( i ) -- automatically add unregistered joystick
								break
							end
						end
					end
					if key then break end
				end
			else -- device is specified
				dev = dev - 5
				if did then -- joystick is specified 
					local j = self.joysticks[ did ]
					if j._hatremaps[ dev ][ 2 ] == false then -- ignore remapped hats
						key = _hatremaps[ j._hatremaps[ dev ].hatmode ][ lj_getHat ( j.number, dev ) ][ 1 ]
					end
				else
					for i = 1, #self.joysticks do -- device but no joystick specified, perform traversal
						local v = self.joysticks[ i ]._hatremaps[ dev ]
						if v[ 2 ] == false then -- ignore remapped hats
							key = _hatremaps[ v.hatmode ][ lj_getHat ( self.joysticks[ i ].number, dev ) ][ 1 ]
							if key then 
								did = i 
								break 
							end
						end
					end
				end
				dev = dev + 5
			end	
		end
		if not key then return end
	end
	
	if not val then val = 1.0 end
	if not inv then inv = 2 end
	if not did then did = 1 end
	
	if dev > 3 and self.joysticks[ did ].fallback then -- this joystick had backup but now actually used - remove backup data
		self.joysticks[ did ].fallback = nil
	end
	
	self:cancelCapture ( )
	if cock._capture.callback then
		le_push ( "controlcaptured", self.id, map .. " " .. option .. " " .. dev ..  " " .. ( key == " " and "space" or key ) .. " " .. inv .. " " .. val .. " " .. did )
	else
		self:bind ( map, option, dev, key, inv, nil, val )
	end
end

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                               HELPERS                                 ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

-- Get literal name of assigned device.
-- func ( self, map, true ) : return all bingings for map
function cock.getBinded ( self, map, option )
	if not option then option = self.defaultOption
	elseif option == true then
		local c = { option = { }, device = { }, key = { }, inverse = { }, delta = { }, joystick = { } }
		local l, ll = self._layout, self._layout.lookup
		for opt, t in pairs ( ll.dev ) do
			
			local d, n = t[ map ], ll.num[ opt ][ map ]
			
			table_insert ( c.option, opt )
			table_insert ( c.device, ( d < 6 ) and d or ( d + l[ d ].hat[ n ] - 1 ) )
			table_insert ( c.key, l[ d ].key[ n ] )
			table_insert ( c.inverse, l[ d ].inv[ n ] )
			table_insert ( c.delta, l[ d ].dlt[ n ] )
			table_insert ( c.joystick, ( d > 3 ) and ( l[ d ].joy[ n ] ) or 1 )
		end
		return c
	end
	local d = self._layout.lookup.num[ option ][ map ]
	if not n then return end -- return 5 nils
	local n, l = self._layout.lookup.dev[ option ][ map ], self._layout[ d ]
	return ( d < 6 ) and d or ( d + l.hat[ n ] - 1 ), l.key[ n ], l.inv[ n ], l.dlt[ n ], ( d > 3) and ( l.joy[ n ] ) or 1
end

-- Helper function for controlcaptured callback.
-- NO COLON NOTATION
function cock.explodeCapturedData ( data )
	local d = { }
	for w in string.gmatch ( data, "%S+" ) do table_insert ( d, w ) end
	return d[ 1 ], d[ 2 ], tonumber ( d[ 3 ] ), ( tonumber ( d[ 3 ] ) == 3 or tonumber ( d[ 3 ] ) > 5 ) and tonumber ( d[ 4 ] ) or ( d[ 4 ] == "space" and " " or d[ 4 ] ), tonumber ( d[ 5 ] ), tonumber ( d[ 6 ] ), tonumber ( d[ 7 ] )
end

-- Find all joysticks and returns list of their names under indices corresponding to joystick number.
-- NO COLON NOTATION
function cock.getJoysticksList ( )
	local list = { }
	-- love.joystick.getJoystickCount since 0.9.0
	for i = 1, lj_getNumJoysticks ( ) do
		if not lj_isOpen ( i ) then lj_open ( i ) end -- remove since 0.9.0
		list[ i ] = lj_getName ( i ) .. " (" .. i .. ")"
	end
	return list
end

-- Convert literal to digital value of a device.
-- NO COLON NOTATION
function cock.convertDevice ( device, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( device ) == "string" ) ) then
		local d = _lookup_devices[ device ]
		if not d then
			if type ( device ) == "string" then  d = tonumber ( device:sub ( 14 ) ) + 5 else d = "joystick hat " .. ( device - 5 ) end
			_lookup_devices[ device ] = d
			_lookup_devices[ d ] = device 
		end
		return d
	end
	return device
end

-- Convert literal to digital value of a key
-- NO COLON NOTATION
function cock.convertKey ( device, key, literal )
	if not device then device = 3 
	elseif type ( device ) == "string" then device = _lookup_devices[ device ] end	
	if ( device == 3 or device == 5 ) and ( literal == nil or ( ( literal == true ) ~= ( type ( key ) == "string" ) ) ) then
		local a = _lookup_axis[ key ]
		if not a then 
			if type ( key ) == "string" then a = tonumber ( key ) else a = tostring ( key ) end
			_lookup_axis[ key ] = a
			_lookup_axis[ a ] = key
		end
		return a
	end
	return key
end
	
-- Convert literal to digital value of an axis.
-- NO COLON NOTATION
function cock.convertdAxis ( axis, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( axis ) == "string" ) ) then
		local a = _lookup_axis[ axis ]
		if not a then 
			if type ( axis ) == "string" then a = tonumber ( axis ) else a = tostring ( axis ) end
			_lookup_axis[ axis ] = a
			_lookup_axis[ a ] = axis
		end
		return a
	end
	return axis
end

-- Convert literal to digital value of inverse.
-- NO COLON NOTATION
function cock.convertInverse ( inverse, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( inverse ) == "string" ) ) then
		return _lookup_modes[ inverse ]
	end
	return inverse
end

-- Convert literal to digital value of delta (exactly the same as previous, that's right). 
-- NO COLON NOTATION
function cock.convertDelta ( delta, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( delta ) == "string" ) ) then
		return _lookup_modes[ delta ]
	end
	return delta
end

-- Convert literal to digital value of joystick hat mode.
-- NO COLON NOTATION
function cock.convertJoystickHatMode ( hatmode, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( hatmode ) == "string" ) ) then
		return _lookup_hatmodes[ hatmode ]
	end
	return hatmode
end

-- Convert literal to digital value of joystick hat number.
-- NO COLON NOTATION
function cock.convertJoystickHat ( hat, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( hat ) == "string" ) ) then
		if type ( hat ) == "string" then
			local d = _lookup_devices[ hat ]
			if not d then 
				d = tonumber ( hat:sub ( 14 ) )
				_lookup_devices[ d + 5 ] = hat
				_lookup_devices[ hat ] = d + 5 
			end
			return d
		else
			local d = _lookup_devices[ hat + 5 ]
			if not d then 
				d = "joystick hat " .. ( hat )
				_lookup_devices[ hat + 5 ] = d
				_lookup_devices[ d ] = hat + 5 
			end
			return d
		end
	end
	return hat
end

-- Convert literal to digital value of joystick id.
-- func ( self, joystick, literal ) : convert self's joysticks
function cock.convertJoystick ( self, joystick, literal )
	if literal == nil or ( ( literal == true ) ~= ( type ( joystick ) == "string" ) ) then
		if type ( joystick ) == "string" then return self.joysticks[ joystick ].number else return self.joysticks[ joystick ] end
	end
	return joystick
end

-- And this is just to mock faggots who use getters and setters for every single little thing, especially if it's used often. It might get inlined in C and pals, but Lua will always introduce function call overhead.
function cock.getCurrent ( self, map )
	error ( "use the 'self.current." .. map .. "' instead, you moron" )
	return self.current[ map ]
end

function cock.getPrevious ( self, map )
	error ( "use the 'self.previous." .. map .. "' instead, you moron" )
	return self.previous[ map ]
end

return cock

--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--
--==                            END OF LIBRARY                             ==--
--== = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = ==--

--[[ equality sheet (you can use either numerical value or literal value ): 
	hat modes:
		 1 = '8-way'
		 2 = '4-way vertical'
		 3 = '4-way horizontal'
		 4 = '4-way clockwise'
		 5 = '4-way counter-clockwise'
		 6 = '4-way diagonal'
	devices:
		 1 = 'keyboard'
		 2 = 'mouse button'
		 3 = 'mouse axis'
		 4 = 'joystick button'
		 5 = 'joystick axis'
		 6 = 'joystick hat' ('joystick hat 1')
		 7 = 'joystick hat 2'
		 8 = 'joystick hat 3', etc.
	axis:
		 1 = 'x'
		 2 = 'y'
		 3 = 'z'
		 4 = 'r'
		 5 = 'u'
		 6 = 'v'
		 7 = '7'
		 8 = '8' 
		 9 = '9', etc.
	inverse:
		 1 = 'positive' '+'
		 2 = 'positive cutoff' '++'
		 3 = 'positive whole' '+='
		-1 = 'negative' '-'
		-2 = 'negative cutoff' '--'
		-3 = 'negative whole' '-='
	delta:
		 0 = 'bypass' '='
		 1 = 'positive' '+'
		 2 = 'positive cutoff' '++'
		-1 = 'negative' '-'
		-2 = 'negative cutoff' '--'
		
hat:sub ( 1, 12 ) == "joystick hat"
--]]